#include "RTClib.h"
#include <LiquidCrystal.h>
#include <EEPROM.h>
#include <Adafruit_NeoPixel.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#define ONE_WIRE_BUS 13
#define LED_PIN    3
#define LED_COUNT 256
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);
RTC_DS1307 rtc;
byte Mode = EEPROM.read(0);
bool Menu = 0;
bool fresh = 0;
int button = 0;
int buttonold = 0;
int index = 0;
byte menval = 0;
byte item = 0;
byte stat = 0;
byte latsim = EEPROM.read(2);
byte moist = EEPROM.read(4);
int moista = 0;
int moistb = 0;
byte moistOn = EEPROM.read(4);
byte onmin = EEPROM.read(5);
byte onhr = EEPROM.read(6);
byte offmin = EEPROM.read(7);
byte offhr = EEPROM.read(8);
byte pump =0;
float tempC;
byte slowloop = 0;
bool pumpfresh = 0;
int monthvals [13] = {0,0,31,59,90,120,151,181,212,243,273,304,334};

 int NYR;
 int NMO;
 int NDY;
 int NHR;
 int NMI;
 int NSE;
 int timeactual;
 int viewtime;
LiquidCrystal lcd(4, 5, 9, 8, 7, 6);//rs,en,d4,d5,d6,d7

void setup() {

 sensors.begin(); 
 pinMode(12, OUTPUT);
 pinMode(11, OUTPUT); // Fan Relay
 pinMode(10, OUTPUT);
 pinMode(A2, INPUT_PULLUP);
 pinMode(A3, INPUT);
 rtc.begin();
 if (! rtc.isrunning()) {
 rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));}
 lcd.begin(20, 4);
strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(255); // Set BRIGHTNESS to about 1/5 (max = 255)
lcd.setCursor(0, 0);
lcd.print("STG Grow Light V1.0");
lcd.setCursor(0, 1);
lcd.print("  The Open Source");
lcd.setCursor(0, 2);
lcd.print("    Grow System");
delay(1000);
lcd.clear();

  lcd.clear();  
}

void loop() {
   delay(100);
 readButtons();
 lampit();
 pumpit();
if (slowloop == 0) { gettemp();}
slowloop ++; if(slowloop == 99){slowloop = 0;}
  if (item == 20){MenuSYS ();} 
  else if(item == 1) {SetTime();}
  else if(item == 2) {SetLat();}
  else if(item == 3) {SetMode();}
  else if(item == 4) {SetMoist();}
  else if(item == 5) {menval = 0; SetOntime();}
  else if(item == 6) {menval = 0; SetOfftime();}
  else if(Mode == 0) {Mode0();  }
  else if(Mode == 1) {Mode1();  }
  else if(Mode == 2) {Mode2();  }
  else if(Mode == 3) {Mode3();  }
 // if (pump == 0) { pump = 1;} else {pump = 0;}
  //digitalWrite(10, pump);
  moista = map(analogRead(A3),0,1023,100,0);
}
  


void displayTime(){
  DateTime now = rtc.now();
  lcd.setCursor(0, 3);
  lcd.print("                    ");
  lcd.setCursor(0, 3);
  lcd.print((now.month()));
  lcd.print("/");
  lcd.print(now.day());
  lcd.print("/");
  lcd.print(now.year());
  lcd.print(" ");
  lcd.print(now.hour());
  lcd.print(":");
  lcd.print(now.minute());
  lcd.print(":");
  lcd.print(now.second()); 
  NMO = now.month();
  NDY = now.day();
  NHR = now.hour();
  NMI = now.minute();
}

void Mode3(){
 timeactual = ((NHR * 60) + (NMI));
 float LAT = EEPROM.read(2);
lcd.clear(); displayTime(); lcd.setCursor(0 ,0); lcd.print("Mode:Sim   M");lcd.print(moista);lcd.print("%");lcd.print(" "); lcd.print(tempC,0);lcd.print("C");

lcd.setCursor(0, 1);
lcd.print(" Lamp Status ");if(stat == 0){lcd.print("OFF");} if(stat == 1){lcd.print("ON");} if (stat == 2) {lcd.print("View");}
lcd.setCursor(0, 2);
lcd.print(" Menu ");

if (button == 1 && fresh == 1) {index -- ;}
  if (index < 1) {index = 2;}
  if (button == 3 && fresh == 1) {index ++;}
  if (index > 2) {index = 1;} 
  lcd.setCursor(0 ,index);
  lcd.write(62);
  displayTime();
 if (button == 2 && fresh == 1 && index == 1 && stat == 2) {stat = 0 ;fresh = 0;}
 if (button == 2 && fresh == 1 && index == 1 && stat < 2) {stat = 2;fresh = 0;}
   
if(button == 2 && fresh ==1 && index == 2) {item = 20;}
if (stat < 2){
byte mon = monthvals[NMO];// number of days into the year when the month starts
int dty = mon + NDY;// add the day of the month to the total
float artic = ( 6 *(EEPROM.read(dty + 99))); // get the value of daylight time for today at artic circle 
float dif = ((artic - 720) * (LAT / 66.0));// figure out the differance betwien the artic circle and the equator
dif = dif/2;
int starttime = 360 - dif;
int stoptime = 1080 + dif;

 
if (timeactual >= starttime){stat = 1;}else {stat = 0;}
if (timeactual >= stoptime){stat = 0;} 
}
}
void Mode2(){
  DateTime now = rtc.now();
lcd.clear(); lcd.setCursor(0 ,0); lcd.print("Mode:Timer M");lcd.print(moista);lcd.print(" "); lcd.print(tempC,0);lcd.print("C");
lcd.setCursor(0, 1);
lcd.print(" Lamp Status ");if(stat == 0){lcd.print("OFF");} if(stat == 1){lcd.print("ON");} if (stat == 2) {lcd.print("View");}
lcd.setCursor(0, 2);
lcd.print(" Menu ");
if (button == 1 && fresh == 1) {index -- ;}
  if (index < 1) {index = 2;}
  if (button == 3 && fresh == 1) {index ++;}
  if (index > 2) {index = 1;} 
  lcd.setCursor(0 ,index);
  lcd.write(62);
  displayTime();
 if (button == 2 && fresh == 1 && index == 1 && stat == 2) {stat = 0 ;fresh = 0;}
 if (button == 2 && fresh == 1 && index == 1 && stat < 2) {stat = 2;fresh = 0;}
   
if(button == 2 && fresh ==1 && index == 2) {item = 20;}
if (stat < 2){
 if (((now.hour()*60) + (now.minute())) >= ((onhr * 60)+ onmin)){stat = 1;}
 if (((now.hour()*60) + (now.minute())) >= ((offhr * 60)+ offmin)){stat = 0;} 
}
}


void Mode1(){
  lcd.clear(); lcd.setCursor(0 ,0); lcd.print("Mode:Man M"); lcd.print(moista);lcd.print(" "); lcd.print(tempC,0);lcd.print("C");
  lcd.setCursor(0, 1);
  lcd.print(" Toggle Lamp ");if(stat == 0){lcd.print("ON");} if(stat == 1){lcd.print("VIEW");} if (stat == 2) {lcd.print("OFF");}
  lcd.setCursor(0, 2);
  lcd.print(" Menu");
  displayTime();
  if (button == 1 && fresh == 1) {index -- ;}
  if (index < 1) {index = 2;}
  if (button == 3 && fresh == 1) {index ++;}
  if (index > 2) {index = 1;} 
  lcd.setCursor(0 ,index);
  lcd.write(62);
  if (button == 2 && fresh == 1 && index == 1) {stat ++ ; if (stat > 2){stat =0;}}
  if(button == 2 && fresh ==1 && index == 2) {item = 20;}
}
void Mode0(){
  lcd.clear();
  lcd.setCursor(0 ,0);
  lcd.print("Mode not set");
  lcd.setCursor(0, 1);
  lcd.print("ENTER for Menu");
  displayTime();
  if(button == 2 && fresh ==1) {item = 20;}
}

void MenuSYS(){
  
 if(index <= 3){
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(" Set Date and Time");
  lcd.setCursor(0, 1);
  lcd.print(" Set Latitude");
  lcd.setCursor(0, 2);
  lcd.print(" Set Mode");
  lcd.setCursor(0, 3);
  lcd.print(" Set Moisture Cntrl");
 }
 else {lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(" Set On Time");
  lcd.setCursor(0, 1);
  lcd.print(" Set Off Time");
  lcd.setCursor(0, 2);
  lcd.print(" Future ");
  lcd.setCursor(0, 3);
  lcd.print(" Future ");
 }
  if (button == 1 && fresh == 1) {index -- ;}
  if (index < 0) {index = 5;}
  if (button == 3 && fresh == 1) {index ++;}
  if (index > 5) {index = 0;} 
  if (index <= 3) {lcd.setCursor(0 ,index);} else {lcd.setCursor(0 ,(index - 4));}
  lcd.write(62);
  if (button == 2 && fresh == 1) {item = index + 1; Menu = 0;index = 0;}
}

 void readButtons() {
   
  int x = (analogRead(A2));
  if (x > 801) { button = 0;}
  else if((x > 749) && (x < 801)) {button = 1;}
  else if((x > 499) && (x < 551)) {button = 2;}
  else if((x > 255) && (x < 310)) {button = 3;}
  else {button = 0;}
  if(button != buttonold) { fresh = 1; buttonold = button; }
  else {fresh = 0;}
  delay(100);
}
void SetTime(){
  DateTime now = rtc.now();
 NYR = now.year();
 NMO = now.month();
 NDY = now.day();
 NHR = now.hour();
 NMI = now.minute();
 NSE = now.second();
  
 while(menval == 0){
  lcd.clear();lcd.print("Set Year"); lcd.setCursor(0, 1); lcd.print("Current ");lcd.print(NYR);
   readButtons();
  if(button == 1 ) {NYR++; delay(200) ; if (NYR > 2255){NYR = 2000;}}
  if(button == 3 ) {NYR--; delay(200) ; if (NYR < 2000){ NYR = 2255;}}
  if(button == 2 && fresh ==1){ rtc.adjust(DateTime(NYR,NMO,NDY,NHR , NMI , NSE)); menval++; }
 }
 while(menval == 1) {
   lcd.clear();lcd.print("Set Month"); lcd.setCursor(0, 1); lcd.print("Curent ");lcd.print(NMO);
   readButtons();
   if(button == 1 ) {NMO++; delay(200) ; if (NMO > 12){NMO = 1;}}
  if(button == 3  ) {NMO--; delay(200) ; if (NMO < 1){ NMO = 12;}}
  if(button == 2 && fresh ==1){ rtc.adjust(DateTime(NYR,NMO,NDY,NHR , NMI , NSE)); menval++; }
  
}
while(menval == 2) {
   lcd.clear();lcd.print("Set Day"); lcd.setCursor(0, 1); lcd.print("Curent ");lcd.print(NDY);
   readButtons();
  if(button == 1 ) {NDY++; delay(200) ; if (NDY > 31){NDY = 1;}}
  if(button == 3 ) {NDY--; delay(200) ; if (NDY < 1){ NDY = 31;}}
  if(button == 2 && fresh ==1){ rtc.adjust(DateTime(NYR,NMO,NDY,NHR , NMI , NSE)); menval++; }
}
while(menval == 3) {
   lcd.clear();lcd.print("Set Hour"); lcd.setCursor(0, 1); lcd.print("Curent ");lcd.print(NHR);
   readButtons();
   if(button == 1  ) {NHR++; delay(200) ; if (NHR > 23){NHR = 0;}}
  if(button == 3 ) {NHR--; delay(200) ; if (NHR < 0){ NHR = 23;}}
  if(button == 2 && fresh ==1){ rtc.adjust(DateTime(NYR,NMO,NDY,NHR , NMI , NSE)); menval++; }
}
while(menval == 4) {
   lcd.clear();lcd.print("Set Minutes"); lcd.setCursor(0, 1); lcd.print("Curent ");lcd.print(NMI);
   readButtons();
  if(button == 1 ) {NMI++;delay(200) ; if (NMI > 60){NMI = 0;}}
  if(button == 3 ) {NMI--;delay(200) ; if (NMI < 0){NMI = 60;}}
  if(button == 2 && fresh ==1){rtc.adjust(DateTime(NYR,NMO,NDY,NHR , NMI , NSE)); menval =0; item = 0; }
}}


 
 

void SetLat(){
  while(item == 2){
  lcd.clear();lcd.print("Set Latitude"); lcd.setCursor(0, 1); lcd.print("Current ");lcd.print (latsim);delay(200) ;
  readButtons(); 
  if(button == 1 ) {latsim ++; if (latsim > 90){latsim = 0;}}
  if(button == 3 ) {latsim --; if (latsim < 0){latsim = 90;}}
  if(button == 2 && fresh ==1){EEPROM.write(2, latsim) ; menval =0; item = 0; }
}}
void SetMode(){
  lcd.clear();lcd.print("Set Mode");
   lcd.setCursor(0, 1);
  lcd.print(" Manual on off");
  lcd.setCursor(0, 2);
  lcd.print(" Simple Timer");
  lcd.setCursor(0, 3);
  lcd.print(" Season Simulation"); 
  if (button == 1 && fresh == 1) {index -- ;}
  if (index < 1) {index = 3;}
  if (button == 3 && fresh == 1) {index ++;}
  if (index > 3) {index = 1;} 
  lcd.setCursor(0 ,index);
  lcd.write(62);delay(200) ;
  if (button == 2 && fresh == 1) {Mode = index ;EEPROM.write(0, Mode); item = 0;}
}
void SetMoist(){
 while(item == 4){
  lcd.clear();lcd.print("Set Moisture Control"); lcd.setCursor(0, 1); lcd.print("Current ");lcd.print (moist); lcd.print (" %"); delay(200) ;
  readButtons(); 
  if(button == 1 ) {moist ++; if (moist > 100){moist = 0;}}
  if(button == 3 ) {moist --; if (moist < 0){moist = 100;}}
  if(button == 2 && fresh ==1){EEPROM.write(4, moist) ; menval =0; item = 0; }
}}
void SetOntime(){
  while (item == 5) {
   while(menval == 0){
    
  lcd.clear();lcd.print("Set On minute"); lcd.setCursor(0, 1); lcd.print("Current ");lcd.print(onmin);
   readButtons();
  if(button == 1 ) {onmin++; delay(200) ; if (onmin > 59){onmin = 0;}}
  if(button == 3 ) {onmin--; delay(200) ;if(onmin > 59) {onmin = 59;} }
  if(button == 2 && fresh ==1){EEPROM.write(5, onmin);  menval++; }
 }
 while(menval == 1) {
   lcd.clear();lcd.print("Set On Hour "); lcd.setCursor(0, 1); lcd.print("Curent ");lcd.print(onhr);
   readButtons();
   if(button == 1 ) {onhr++; delay(200) ; if (onhr > 23){onhr = 0;}}
  if(button == 3  ) {onhr--; delay(200) ; if (onhr <= 0){ onhr = 23;}}
  if(button == 2 && fresh ==1){EEPROM.write(6, onhr); menval = 0; item = 0; }
  
}  
}
}
 

void SetOfftime(){
 while (item == 6) {
   while(menval == 0){
  lcd.clear();lcd.print("Set Off minute"); lcd.setCursor(0, 1); lcd.print("Current ");lcd.print(offmin);
   readButtons();
  if(button == 1 ) {offmin++; delay(200) ; if (offmin > 59){offmin = 0;}}
  if(button == 3 ) {offmin--; delay(200) ;if(offmin > 59){ offmin = 59;}}
  if(button == 2 && fresh ==1){EEPROM.write(7, offmin);  menval++; }
 }
 while(menval == 1) {
   lcd.clear();lcd.print("Set Off Hour "); lcd.setCursor(0, 1); lcd.print("Curent ");lcd.print(offhr);
   readButtons();
   if(button == 1 ) {offhr++; delay(200) ; if (offhr > 23){offhr = 0;}}
  if(button == 3  ) {offhr--; delay(200) ; if (offhr <= 0){ offhr = 23;}}
  if(button == 2 && fresh ==1){EEPROM.write(8, offhr); menval = 0; item = 0; }  
}  
}  
}
void lampit(){
 if (stat == 0){ colorWipe(strip.Color(0,   0,   0)); digitalWrite(11 , LOW);}
 if (stat == 1){ colorWipe(strip.Color(255,   0,   255)); digitalWrite(11 , HIGH); }
 if (stat == 2){ colorWipe(strip.Color(255,   255,   255));  digitalWrite(11 , HIGH); }
}
void colorWipe(uint32_t color) {
 for(int i=0; i<strip.numPixels(); i++){
  strip.setPixelColor(i, color);
 }
  strip.show();
 }
 void gettemp(){
  sensors.requestTemperatures(); 
  tempC = sensors.getTempCByIndex(0);
 }
 void pumpit(){
  
  moista = map(analogRead(A3),0,1023,100,0);
  DateTime now = rtc.now();
  NMI = now.minute();
  if(NMI == 57 && pumpfresh == 1){
   int moistd = EEPROM.read(4); if(moista < (moistd + 2)){
     digitalWrite(10,HIGH); delay(10000);digitalWrite(10, LOW); pumpfresh = 0; 
    }
  }
  if(NMI != 57){ pumpfresh = 1;}
 }
